PRO irc_specext,image,specimage,source_table,image3d,specimage3d,ext_source_table, $
                noise_for_find=noise_for_find,FWHM=FWHM, $
                auto_specbox_x_shift=auto_specbox_x_shift, $
                for_skysub_only=for_skysub_only,skysub=skysub, $
                fov_mask=fov_mask,no_mask=no_mask, $
                source_table_offset_x_value=source_table_offset_x_value, $
                source_table_offset_y_value=source_table_offset_y_value, $
                noisemap_whole=noisemap_whole,noisemap_n=noisemap_n, $
                short=short,interactive=interactive,no_x_shift=no_x_shift
 
  common gui,logger
  
  if ~ defined(noise_for_find) then autonoisecalc=1B
  if ~ keyword_set(FWHM) then FWHM=!IRC_SPECRED_SOURCEDETECTPARAM.fwhm_for_find

  if keyword_set(short) || (~ keyword_set(interactive) && ~ keyword_set(for_skysub_only)) then goto,no_find

  case 1 of
     !IRC_SPECRED_OBSPARAM.slit_mode EQ 1B: $
        set_slitpos,source_table
     
     (keyword_set(for_skysub_only)): begin
;        (strlen(ext_source_table) EQ 0 && n_source EQ 0 && keyword_set(for_skysub_only)): $ ; automatically find stars...
        ircfind,image,source_table,fwhm,noise_for_find=noise_for_find,skysub=skysub,/autonoisecalc, $
                /only_bright_objects,/for_skysub_only ;,/no_photo
     end
     
     (strlen(ext_source_table) EQ 0 && ~ keyword_set(for_skysub_only)): $
;       (Strlen(ext_source_table) EQ 0 && n_source EQ 0 && ~ Keyword_set(for_skysub_only)): $ ; interactively find stars...
        ircfind,image,source_table,fwhm,noise_for_find=noise_for_find,skysub=skysub,/autonoisecalc, $
        /interactive
     
     (strlen(ext_source_table) GT 0 && ~ keyword_set(for_skysub_only)): begin
;        (strlen(ext_source_table) NE 0 && ~ keyword_set(for_skysub_only)): $
        load_ext_source_table,source_table,ext_source_table,image=image, $
                              source_table_offset_x_value=source_table_offset_x_value, $
                              source_table_offset_y_value=source_table_offset_y_value
     end
     else: message,'Error (irc_specext): Case no match!'
  endcase
  
no_find:
  
; Set specbox info
  if ~ defined(no_x_shift) then set_specbox_x_shift,mean_d_offset,for_skysub_only=for_skysub_only,short=short

  calc_specbox_pos,source_table
  
; Do source extraction
  make_image_n,image,specimage,source_table,image3d,specimage3d
  if defined(noisemap_whole) then begin
     if ~ keyword_set(short) then $
        make_image_n,noisemap_whole[*,*,1],noisemap_whole[*,*,1],source_table,tmp,noisemap_n $
     else $
        make_image_n,noisemap_whole[*,*,0],noisemap_whole[*,*,0],source_table,tmp,noisemap_n
  endif
  
  make_mask_n,source_table,mask_specimage_n,fov_mask=fov_mask
  make_mask_n,source_table,mask_specimage_n_remove_all,/remove_all_source,fov_mask=fov_mask

  if keyword_set(no_mask) then mask_specimage_n[*,*,*]=1.
  
  if keyword_set(short) || !IRC_SPECRED_OBSPARAM.slit_mode EQ 1B then return
  
;  if keyword_set(for_skysub_only) then begin
;  if ~ (keyword_set(for_skysub_only) && (NIR() || SG1())) then return
  if ~ keyword_set(for_skysub_only) then return
  if (SG1() && !IRC_SPECRED_PROCESSOPTION.faint_source_mode) || SG2() || LG2() then return
;  if (SG1() && !IRC_SPECRED_PROCESSOPTION.faint_source_mode) || LG2() then return

  if ~ defined(no_x_shift) then begin
     logger->append,['  Measuring X pos of spec images... pass 1']
     calc_shift_specbox_x,specimage3d,mask_specimage_n,mask_specimage_n_remove_all,source_table, $
                          mean_d_offset,sigma_mean_d_offset,skysub=skysub
     logger->append,['     Self-measured specbox X offset: '+strim(mean_d_offset[0])+'+-'+strim(sigma_mean_d_offset[0])+' (pix)']
; apply X offset
     !IRC_SPECRED_SPECEXTRACTPARAM.x_offset+=mean_d_offset[0]
     !IRC_SPECRED_SPECEXTRACTPARAM.x_offset_rel+=mean_d_offset[0]
     source_table.spec_x+=mean_d_offset[0]
  endif

; endif

; make final mask/specimage3d
  make_image_n,image,specimage,source_table,image3d,specimage3d
  if defined(noisemap_whole) then begin
     if ~ keyword_set(short) then $
        make_image_n,noisemap_whole[*,*,1],noisemap_whole[*,*,1],source_table,tmp,noisemap_n $
     else $
        make_image_n,noisemap_whole[*,*,0],noisemap_whole[*,*,0],source_table,tmp,noisemap_n
  endif
  make_mask_n,source_table,mask_specimage_n,fov_mask=fov_mask

;  print,!IRC_SPECRED_MISC.first_pass,!IRC_SPECRED_SPECEXTRACTPARAM.x_offset_rel,mean_d_offset[0]
  if keyword_set(for_skysub_only) then begin
     if NP() then write_specbox_shift_x,!IRC_SPECRED_SPECEXTRACTPARAM.x_offset_rel, $
                                        filename=!IRC_SPECRED_DIR.workdir+'/NP_SPECBOX_SHIFT_X.dat'
     if NG() then write_specbox_shift_x,!IRC_SPECRED_SPECEXTRACTPARAM.x_offset_rel, $
                                        filename=!IRC_SPECRED_DIR.workdir+'/NG_SPECBOX_SHIFT_X.dat'
  endif

END
